%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%If do not use the parallel algarithm, need to change parfor loop to for
%inputs: n the sample size; umin and umax are postive values
%outputs: coverage probability
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Re=Varyingucomeasures(n,umin,umax)
m=10000;
CP=zeros(1,3);kn=floor(sqrt(n));
%matlabpool open 
parfor k=1:m
    clc;
     k
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
DJx=0.1*poissrnd(4/n,n,1).*randn(n,1);DJy=0.1*poissrnd(4/n,n,1).*randn(n,1);
Wx=randn(n,1)/sqrt(n);Wy=randn(n,1)/sqrt(n);Bx=randn(n,1)/sqrt(n);By=randn(n,1)/sqrt(n);Bbeta=randn(n,1)/sqrt(n);
Vx=zeros(n+1,1);Vy=zeros(n+1,1);beta=zeros(n+1,1);
Vx(1,1)=1;Vy(1,1)=1;beta(1,1)=1;
for j=1:n
    Vx(j+1,1)=Vx(j,1)+0.03*(1-Vx(j,1))/n+0.18*sqrt(Vx(j,1))*Bx(j,1);
    Vy(j+1,1)=Vy(j,1)+0.03*(1-Vy(j,1))/n+0.18*sqrt(Vy(j,1))*By(j,1);
    beta(j+1,1)=beta(j,1)+0.03*(1-beta(j,1))/n+0.18*sqrt(beta(j,1))*Bbeta(j,1);
end
Dx=sqrt(Vx(1:n,1)).*Wx+0.1*DJx;
Dy=beta(1:n,1).*Dx+sqrt(Vy(1:n,1)).*Wy+0.1*DJy;
V1=Vx(n/2);V2=beta(n/2)^2*Vx(n/2)+Vy(n/2);cov=beta(n/2)*Vx(n/2);rho=cov/sqrt(V1*V2);Beta=cov/V1;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
uc=umin:0.01:umax;un=length(uc);
est=zeros(1,5);
for q=1:un
    u=uc(q);
xix=cos(sqrt(2*u)*sqrt(n)*Dx);xiy=cos(sqrt(2*u)*sqrt(n)*Dy);xia=cos(sqrt(2*u)*sqrt(n)*(Dx+Dy));xib=cos(sqrt(2*u)*sqrt(n)*(Dx-Dy));
A1=-log(mean(xix(n/2:(n/2+kn))))/u;B1=-log(mean(xiy(n/2:(n/2+kn))))/u;C1=(log(mean(xib(n/2:(n/2+kn))))-log(mean(xia(n/2:(n/2+kn)))))/(4*u);
corn1=C1/sqrt(A1*B1);Betn1=C1/A1;
est=est+[A1 B1 C1 corn1 Betn1];
end
Cx=est(1)/un;Cy=est(2)/un;Cxy=est(3)/un;rhon=est(4)/un;Betan=est(5)/un;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%Bootstrap%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Bm=999;
NDx=Dx((n/2+1):(n/2+kn));
NDy=Dy((n/2+1):(n/2+kn));
BVDx=NDx(1:kn-1).*NDx(2:kn);BVx=pi/2*sum(abs(BVDx),1)*n/kn;
BVDy=NDy(1:kn-1).*NDy(2:kn);BVy=pi/2*sum(abs(BVDy),1)*n/kn;
lovix=NDx.^2.*(abs(NDx)<7*sqrt(BVx)*(1/n)^0.4);
loviy=NDy.^2.*(abs(NDy)<7*sqrt(BVy)*(1/n)^0.4);
lovixy=NDx.*NDy.*(abs(NDx)<7*sqrt(BVx)*(1/n)^0.4).*(abs(NDy)<7*sqrt(BVy)*(1/n)^0.4);
chatx=sum(lovix,1)*n/kn;
chaty=sum(loviy,1)*n/kn;
chatxy=sum(lovixy,1)*n/kn;
etaBL1=randn(kn,Bm);etaBL2=randn(kn,Bm);
SBLCxy=zeros(Bm,1);SBLrho=zeros(Bm,1);SBLbeta=zeros(Bm,1);
for j=1:Bm
         uc=umin:0.01:umax;un=length(uc);
      estB=zeros(1,3);
      for q=1:un
         u=uc(q);
  DxB=sqrt(1/n)*sqrt(chatx).*etaBL1(:,j);
  DyB=sqrt(1/n)*chatxy/sqrt(chatx).*etaBL1(:,j)+sqrt(1/n)*sqrt(chaty-chatxy^2/chatx).*etaBL2(:,j);
  xixB=cos(sqrt(2*u)*DxB);
  xiyB=cos(sqrt(2*u)*DyB);
  xixyB1=cos(sqrt(2*u)*(DxB+DyB));
  xixyB2=cos(sqrt(2*u)*(DxB-DyB));
  BLx=mean(xixB);
  BLy=mean(xiyB);
  BLxy1=mean(xixyB1);BLxy2=mean(xixyB2);
  LBLx=-log(max(BLx,1/kn))/u;
  LBLy=-log(max(BLy,1/kn))/u;
  LBLxy=(log(max(BLxy2,1/kn))-log(max(BLxy1,1/kn)))/(4*u);
   estB=estB+[LBLx LBLy LBLxy];
      end
    CxB=estB(1)/un;CyB=estB(2)/un; CxyB=estB(3)/un;   
  SBLCxy(j,1)=sqrt(kn)*abs(CxyB-chatxy);
  SBLrho(j,1)=sqrt(kn)*abs(CxyB/sqrt(CxB*CyB)-chatxy/sqrt(chatx*chaty));
  SBLbeta(j,1)=sqrt(kn)*abs(CxyB/CxB-chatxy/chatx);
end
qLCxy=quantile(SBLCxy,0.95);
LBCIlCxy=Cxy-sqrt(1/kn)*qLCxy;LBCIuCxy=Cxy+sqrt(1/kn)*qLCxy;
LGBCxy=(LBCIlCxy<=cov)*(cov<=LBCIuCxy);

qLrho=quantile(SBLrho,0.95);
LBCIlrho=rhon-sqrt(1/kn)*qLrho;LBCIurho=rhon+sqrt(1/kn)*qLrho;
LGBrho=(LBCIlrho<=rho)*(rho<=LBCIurho);

qLbeta=quantile(SBLbeta,0.95);
LBCIlbeta=Betan-sqrt(1/kn)*qLbeta;LBCIubeta=Betan+sqrt(1/kn)*qLbeta;
LGBbeta=(LBCIlbeta<=Beta)*(Beta<=LBCIubeta);

CP=CP+[LGBCxy LGBrho LGBbeta];
end
%matlabpool close
Re=100*CP/m;




