%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%If do not use the parallel algarithm, need to change parfor loop to for
%inputs: n the sample size; umax and umin are postive values
%outputs: Coverage probability
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Re=Varyinguvol(n,umin,umax)
m=10000;
CP=zeros(1,2);kn=floor(sqrt(n));
%matlabpool open 
parfor k=1:m
    clc;
     k
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
DJx=0.1*poissrnd(4/n,n,1).*randn(n,1);DJy=0.1*poissrnd(4/n,n,1).*randn(n,1);
Wx=randn(n,1)/sqrt(n);Wy=randn(n,1)/sqrt(n);Bx=randn(n,1)/sqrt(n);By=randn(n,1)/sqrt(n);Bbeta=randn(n,1)/sqrt(n);
Vx=zeros(n+1,1);Vy=zeros(n+1,1);beta=zeros(n+1,1);
Vx(1,1)=1;Vy(1,1)=1;beta(1,1)=1;
for j=1:n
    Vx(j+1,1)=Vx(j,1)+0.03*(1-Vx(j,1))/n+0.18*sqrt(Vx(j,1))*Bx(j,1);
    Vy(j+1,1)=Vy(j,1)+0.03*(1-Vy(j,1))/n+0.18*sqrt(Vy(j,1))*By(j,1);
    beta(j+1,1)=beta(j,1)+0.03*(1-beta(j,1))/n+0.18*sqrt(beta(j,1))*Bbeta(j,1);
end
Dx=sqrt(Vx(1:n,1)).*Wx+0.1*DJx;
Dy=beta(1:n,1).*Dx+sqrt(Vy(1:n,1)).*Wy+0.1*DJy;
V1=Vx(n/2);V2=beta(n/2)^2*Vx(n/2)+Vy(n/2);cov=beta(n/2)*Vx(n/2);rho=cov/sqrt(V1*V2);Beta=cov/V1;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
uc=umin:0.01:umax;un=length(uc);
est=zeros(1,2);
for q=1:un
    u=uc(q);
xix=cos(sqrt(2*u)*sqrt(n)*Dx);xiy=cos(sqrt(2*u)*sqrt(n)*Dy);
A1=-log(mean(xix(n/2:(n/2+kn))))/u;B1=-log(mean(xiy(n/2:(n/2+kn))))/u;
est=est+[A1 B1];
end
Cx=est(1)/un;Cy=est(2)/un;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%Bootstrap%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Bm=999;
NDx=Dx((n/2+1):(n/2+kn));
NDy=Dy((n/2+1):(n/2+kn));
BVDx=NDx(1:kn-1).*NDx(2:kn);BVx=pi/2*sum(abs(BVDx),1)*n/kn;
BVDy=NDy(1:kn-1).*NDy(2:kn);BVy=pi/2*sum(abs(BVDy),1)*n/kn;
lovix=NDx.^2.*(abs(NDx)<7*sqrt(BVx)*(1/n)^0.4);
loviy=NDy.^2.*(abs(NDy)<7*sqrt(BVy)*(1/n)^0.4);
chatx=sum(lovix,1)*n/kn;
chaty=sum(loviy,1)*n/kn;
etaBL=randn(kn,Bm);
SBLx=zeros(Bm,1);SBLy=zeros(Bm,1);
for j=1:Bm
    uc=umin:0.01:umax;un=length(uc);
      estB=zeros(1,2);
      for q=1:un
         u=uc(q);
  xiBLx=cos(sqrt(2*u*chatx).*etaBL(:,j));
  xiBLy=cos(sqrt(2*u*chaty).*etaBL(:,j));
  BLx=mean(xiBLx);
  BLy=mean(xiBLy);
  LBLx=-log(max(BLx,1/kn))/u;
  LBLy=-log(max(BLy,1/kn))/u;
  estB=estB+[LBLx LBLy];
      end
   CxB=estB(1)/un;CyB=estB(2)/un;
  SBLx(j,1)=sqrt(kn)*abs(CxB-chatx);
  SBLy(j,1)=sqrt(kn)*abs(CyB-chaty);
end
qLx=quantile(SBLx,0.95);
LBCIlx=Cx-sqrt(1/kn)*qLx;LBCIux=Cx+sqrt(1/kn)*qLx;
LGBx=(LBCIlx<=V1)*(V1<=LBCIux);
qLy=quantile(SBLy,0.95);
LBCIly=Cy-sqrt(1/kn)*qLy;LBCIuy=Cy+sqrt(1/kn)*qLy;
LGBy=(LBCIly<=V2)*(V2<=LBCIuy)
CP=CP+[LGBx LGBy];
end
%matlabpool close
Re=100*CP/m;