%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%If do not use the parallel algarithm, need to change parfor loop to for
%inputs: n the sample size; u a postive value
%outputs: Relative bias and RMSE
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Re=Fixedu(n,u)
m=10000;D1=zeros(m,5);
kn=floor(sqrt(n));
%matlabpool open 
for k=1:m
    clc;
   k
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
DJx=0.1*poissrnd(4/n,n,1).*randn(n,1);DJy=0.1*poissrnd(4/n,n,1).*randn(n,1);
Wx=randn(n,1)/sqrt(n);Wy=randn(n,1)/sqrt(n);Bx=randn(n,1)/sqrt(n);By=randn(n,1)/sqrt(n);Bbeta=randn(n,1)/sqrt(n);
Vx=zeros(n+1,1);Vy=zeros(n+1,1);beta=zeros(n+1,1);
Vx(1,1)=1;Vy(1,1)=1;beta(1,1)=1;
for j=1:n
    Vx(j+1,1)=Vx(j,1)+0.03*(1-Vx(j,1))/n+0.18*sqrt(Vx(j,1))*Bx(j,1);
    Vy(j+1,1)=Vy(j,1)+0.03*(1-Vy(j,1))/n+0.18*sqrt(Vy(j,1))*By(j,1);
    beta(j+1,1)=beta(j,1)+0.03*(1-beta(j,1))/n+0.18*sqrt(beta(j,1))*Bbeta(j,1);
end
DX=sqrt(Vx(1:n,1)).*Wx+DJx;
DY=beta(1:n,1).*DX+sqrt(Vy(1:n,1)).*Wy+DJy;
V1=Vx(n/2);V2=beta(n/2)^2*Vx(n/2)+Vy(n/2);cov=beta(n/2)*Vx(n/2);cor=cov/sqrt(V1*V2);Bet=cov/V1;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xix=cos(sqrt(2*u)*sqrt(n)*DX);xiy=cos(sqrt(2*u)*sqrt(n)*DY);xia=cos(sqrt(2*u)*sqrt(n)*(DX+DY));xib=cos(sqrt(2*u)*sqrt(n)*(DX-DY));
A1=-log(max(mean(xix(n/2:(n/2+kn))),1/kn))/u;
B1=-log(max(mean(xiy(n/2:(n/2+kn))),1/kn))/u;
C1=(log(max(mean(xib(n/2:(n/2+kn))),1/kn))-log(max(mean(xia(n/2:(n/2+kn))),1/kn)))/(4*u);
corn1=C1/sqrt(A1*B1);Betn1=C1/A1;
D1(k,1)=(A1-V1)/V1;D1(k,2)=(B1-V2)/V2;D1(k,3)=(C1-cov)/cov;D1(k,4)=(corn1-cor)/cor;D1(k,5)=(Betn1-Bet)/Bet;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
end
D1a=D1(:,1);D1b=D1(:,2);D1c=D1(:,3);D1d=D1(:,4);D1e=D1(:,5);
E1=[mean(D1a) mean(D1b) mean(D1c) mean(D1d) mean(D1e);std(D1a) std(D1b) std(D1c) std(D1d) std(D1e)];
Re=[E1(1,:);sqrt(E1(1,:).^2+E1(2,:).^2)];