%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%If do not use the parallel algarithm, need to change parfor loop to for
%inputs: n the sample size;
%outputs: Relative bias and RMSE
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Re=TLRV(n)
m=10000;D=zeros(m,5);
kn=floor(sqrt(n));
%matlabpool open 
for k=1:m
    clc;
   k
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
DJx=0.1*poissrnd(4/n,n,1).*randn(n,1);DJy=0.1*poissrnd(4/n,n,1).*randn(n,1);
Wx=randn(n,1)/sqrt(n);Wy=randn(n,1)/sqrt(n);Bx=randn(n,1)/sqrt(n);By=randn(n,1)/sqrt(n);Bbeta=randn(n,1)/sqrt(n);
Vx=zeros(n+1,1);Vy=zeros(n+1,1);beta=zeros(n+1,1);
Vx(1,1)=1;Vy(1,1)=1;beta(1,1)=1;
for j=1:n
    Vx(j+1,1)=Vx(j,1)+0.03*(1-Vx(j,1))/n+0.18*sqrt(Vx(j,1))*Bx(j,1);
    Vy(j+1,1)=Vy(j,1)+0.03*(1-Vy(j,1))/n+0.18*sqrt(Vy(j,1))*By(j,1);
    beta(j+1,1)=beta(j,1)+0.03*(1-beta(j,1))/n+0.18*sqrt(beta(j,1))*Bbeta(j,1);
end
DX=sqrt(Vx(1:n,1)).*Wx+DJx;
DY=beta(1:n,1).*DX+sqrt(Vy(1:n,1)).*Wy+DJy;
V1=Vx(n/2);V2=beta(n/2)^2*Vx(n/2)+Vy(n/2);cov=beta(n/2)*Vx(n/2);cor=cov/sqrt(V1*V2);Bet=cov/V1;
alpha=7;varpi=0.4;
DX=DX.*(abs(DX)<=alpha*(1/n)^varpi);DY=DY.*(abs(DX)<=alpha*(1/n)^varpi);
A=n/kn*sum(DX(n/2:(n/2+kn)).^2);B=n/kn*sum(DY(n/2:(n/2+kn)).^2);C=n/kn*sum(DX(n/2:(n/2+kn)).*DY(n/2:(n/2+kn)));corn=C/sqrt(A*B);Betn=C/A;
D(k,1)=(A-V1)/V1;D(k,2)=(B-V2)/V2;D(k,3)=(C-cov)/cov;D(k,4)=(corn-cor)/cor;D(k,5)=(Betn-Bet)/Bet;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
end
E=[mean(D,1);std(D(:,1)) std(D(:,2)) std(D(:,3)) std(D(:,4)) std(D(:,5))];
Re=[E(1,:);sqrt(E(1,:).^2+E(2,:).^2)];
[sum((D(:,1)<=0)) sum((D(:,1)>=0))]/m
